opal/util/argv.h File Reference.TH "opal/util/argv.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/util/argv.h \- Generic routines for 'argv'-like handling. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'include/types.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_argv_append\fP (int *argc, char ***argv, const char *arg)"
.br
.RI "\fIAppend a string (by value) to an new or existing NULL-terminated argv array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_argv_append_nosize\fP (char ***argv, const char *arg)"
.br
.RI "\fIAppend to an argv-style array, but ignore the size of the array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_argv_free\fP (char **argv)"
.br
.RI "\fIFree a NULL-terminated argv array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC char ** \fBopal_argv_split\fP (const char *src_string, int delimiter)"
.br
.RI "\fISplit a string into a NULL-terminated argv array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_argv_count\fP (char **argv)"
.br
.RI "\fIReturn the length of a NULL-terminated argv array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC char * \fBopal_argv_join\fP (char **argv, int delimiter)"
.br
.RI "\fIJoin all the elements of an argv array into a single newly-allocated string. \fP"
.ti -1c
.RI "OMPI_DECLSPEC size_t \fBopal_argv_len\fP (char **argv)"
.br
.RI "\fIReturn the number of bytes consumed by an argv array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC char ** \fBopal_argv_copy\fP (char **argv)"
.br
.RI "\fICopy a NULL-terminated argv array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_argv_delete\fP (int *argc, char ***argv, int start, int num_to_delete)"
.br
.RI "\fIDelete one or more tokens from the middle of an argv. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_argv_insert\fP (char ***target, int start, char **source)"
.br
.RI "\fIInsert one argv array into the middle of another. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Generic routines for 'argv'-like handling. 

Helpful for creating arrays of strings, especially when creating command lines.
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int opal_argv_append (int * argc, char *** argv, const char * arg)"
.PP
Append a string (by value) to an new or existing NULL-terminated argv array. 
.PP
\fBParameters:\fP
.RS 4
\fIargc\fP Pointer to the length of the argv array. Must not be NULL. 
.br
\fIargv\fP Pointer to an argv array. 
.br
\fIstr\fP Pointer to the string to append.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP On success 
.br
\fIOMPI_ERROR\fP On failure
.RE
.PP
This function adds a string to an argv array of strings by value; it is permissable to pass a string on the stack as the str argument to this function.
.PP
To add the first entry to an argv array, call this function with (*argv == NULL). This function will allocate an array of length 2; the first entry will point to a copy of the string passed in arg, the second entry will be set to NULL.
.PP
If (*argv != NULL), it will be realloc'ed to be 1 (char*) larger, and the next-to-last entry will point to a copy of the string passed in arg. The last entry will be set to NULL.
.PP
Just to reinforce what was stated above: the string is copied by value into the argv array; there is no need to keep the original string (i.e., the arg parameter) after invoking this function. 
.SS "OMPI_DECLSPEC int opal_argv_append_nosize (char *** argv, const char * arg)"
.PP
Append to an argv-style array, but ignore the size of the array. 
.PP
\fBParameters:\fP
.RS 4
\fIargv\fP Pointer to an argv array. 
.br
\fIstr\fP Pointer to the string to append.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP On success 
.br
\fIOMPI_ERROR\fP On failure
.RE
.PP
This function is identical to the \fBopal_argv_append()\fP function except that it does not take a pointer to an argc (integer representing the size of the array). This is handy for argv-style arrays that do not have integers that are actively maintaing their sizes. 
.SS "OMPI_DECLSPEC char** opal_argv_copy (char ** argv)"
.PP
Copy a NULL-terminated argv array. 
.PP
\fBParameters:\fP
.RS 4
\fIargv\fP The input argv array.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIargv\fP Copied argv array on success. 
.br
\fINULL\fP On failure.
.RE
.PP
Copy an argv array, including copying all off its strings. Specifically, the output argv will be an array of the same length as the input argv, and strcmp(argv_in[i], argv_out[i]) will be 0. 
.SS "OMPI_DECLSPEC int opal_argv_count (char ** argv)"
.PP
Return the length of a NULL-terminated argv array. 
.PP
\fBParameters:\fP
.RS 4
\fIargv\fP The input argv array.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI0\fP If NULL is passed as argv. 
.br
\fIcount\fP Number of entries in the argv array.
.RE
.PP
The argv array must be NULL-terminated. 
.SS "OMPI_DECLSPEC int opal_argv_delete (int * argc, char *** argv, int start, int num_to_delete)"
.PP
Delete one or more tokens from the middle of an argv. 
.PP
\fBParameters:\fP
.RS 4
\fIargv\fP The argv to delete from 
.br
\fIstart\fP The index of the first token to delete 
.br
\fInum_to_delete\fP How many tokens to delete
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP Always
.RE
.PP
Delete some tokens from within an existing argv. The start parameter specifies the first token to delete, and will delete (num_to_delete-1) tokens following it. argv will be realloc()ed to *argc - num_deleted size.
.PP
If start is beyond the end of the argv array, this function is a no-op.
.PP
If num_to_delete runs beyond the end of the argv array, this function will delete all tokens starting with start to the end of the array.
.PP
All deleted items in the argv array will have their contents free()ed (it is assumed that the argv 'owns' the memory that the pointer points to). 
.SS "OMPI_DECLSPEC void opal_argv_free (char ** argv)"
.PP
Free a NULL-terminated argv array. 
.PP
\fBParameters:\fP
.RS 4
\fIargv\fP Argv array to free.
.RE
.PP
This function frees an argv array and all of the strings that it contains. Since the argv parameter is passed by value, it is not set to NULL in the caller's scope upon return.
.PP
It is safe to invoke this function with a NULL pointer. It is not safe to invoke this function with a non-NULL-terminated argv array. 
.SS "OMPI_DECLSPEC int opal_argv_insert (char *** target, int start, char ** source)"
.PP
Insert one argv array into the middle of another. 
.PP
\fBParameters:\fP
.RS 4
\fItarget\fP The argv to insert tokens into 
.br
\fIstart\fP Index where the first token will be placed in target 
.br
\fIsource\fP The argv to copy tokens from
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP upon success 
.br
\fIOMPI_BAD_PARAM\fP if any parameters are non-sensical
.RE
.PP
This function takes one arg and inserts it in the middle of another. The first token in source will be insertted at index start in the target argv; all other tokens will follow it. Similar to \fBopal_argv_append()\fP, the target may be realloc()'ed to accomodate the new storage requirements.
.PP
The source array is left unaffected -- its contents are copied by value over to the target array (i.e., the strings that source points to are strdup'ed into the new locations in target). 
.SS "OMPI_DECLSPEC char* opal_argv_join (char ** argv, int delimiter)"
.PP
Join all the elements of an argv array into a single newly-allocated string. 
.PP
\fBParameters:\fP
.RS 4
\fIargv\fP The input argv array. 
.br
\fIdelimiter\fP Delimiter character placed between each argv string.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fInew_string\fP Output string on success. 
.br
\fINULL\fP On failure.
.RE
.PP
Similar to the Perl join function, this function takes an input argv and joins them into into a single string separated by the delimiter character.
.PP
It is the callers responsibility to free the returned string. 
.SS "OMPI_DECLSPEC size_t opal_argv_len (char ** argv)"
.PP
Return the number of bytes consumed by an argv array. 
.PP
\fBParameters:\fP
.RS 4
\fIargv\fP The input argv array.
.RE
.PP
Count the number of bytes consumed by a NULL-terminated argv array. This includes the number of bytes used by each of the strings as well as the pointers used in the argv array. 
.SS "OMPI_DECLSPEC char** opal_argv_split (const char * src_string, int delimiter)"
.PP
Split a string into a NULL-terminated argv array. 
.PP
\fBParameters:\fP
.RS 4
\fIsrc_string\fP Input string. 
.br
\fIdelimiter\fP Delimiter character.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIargv\fP pointer to new argv array on success 
.br
\fINULL\fP on error
.RE
.PP
All strings are insertted into the argv array by value; the newly-allocated array makes no references to the src_string argument (i.e., it can be freed after calling this function without invalidating the output argv). 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
